unit Question1_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, ADODB, Grids, DBGrids, ExtCtrls, Buttons;

type
  TfrmRec = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    btnA: TButton;
    btnB: TButton;
    btnC: TButton;
    btnD: TButton;
    btnE: TButton;
    btnF: TButton;
    btnG: TButton;
    BitBtn1: TBitBtn;
    qryRec: TADOQuery;
    tblRecAg: TDataSource;
    grdRec: TDBGrid;

    procedure btnAClick(Sender: TObject);
    procedure btnBClick(Sender: TObject);
    procedure btnCClick(Sender: TObject);
    procedure btnDClick(Sender: TObject);
    procedure btnEClick(Sender: TObject);
    procedure btnFClick(Sender: TObject);
    procedure btnGClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmRec: TfrmRec;

implementation

{$R *.dfm}


procedure TfrmRec.btnAClick(Sender: TObject);
begin
  qryRec.Active := False;
  qryRec.SQL.Text :=  'SELECT * FROM tblDams ORDER BY HeightOfWall Asc';
  qryRec.Active := True;
end;

procedure TfrmRec.btnBClick(Sender: TObject);
var
  pr : String;
begin
  qryRec.Active := False;
  pr := InputBox('Large Towns', 'Enter the name of the province', '');
  qryRec.SQL.Text := 'SELECT TownName, Population FROM tblTowns WHERE Population > 100000 AND Province = "' + pr + '"';
  qryRec.Active := True;
end;

procedure TfrmRec.btnCClick(Sender: TObject);
begin
  qryRec.Active := False;
  qryRec.SQL.Text := 'SELECT DamID, DamName, ROUND(DamLevel / Capacity * 100, 1) AS Percentage, (YEAR(NOW()) - YearCompleted) AS Age FROM tblDams';
  qryRec.Active := True;
end;

procedure TfrmRec.btnDClick(Sender: TObject);
begin
  qryRec.Active := False;
  qryRec.SQL.Text := 'SELECT Province, COUNT(*) AS CriticalTowns FROM tblTowns WHERE WaterRestrictions = TRUE GROUP BY Province';
  qryRec.Active := True;
end;

procedure TfrmRec.btnEClick(Sender: TObject);
begin
  qryRec.Active := False;
  qryRec.SQL.Text := 'SELECT DISTINCT Province FROM tblTowns, tblDams WHERE tblTowns.DamID = tblDams.DamID AND River LIKE "Vaal%"';
  qryRec.Active := True;

end;

procedure TfrmRec.btnFClick(Sender: TObject);
begin
  qryRec.Active := False;
  qryRec.SQL.Text := 'UPDATE tblTowns SET WaterRestrictions = True WHERE Province = "North West" ';
  qryRec.ExecSQL;
  MessageDlg('Records Processed Successfully',mtInformation,[mbok],0);
end;

procedure TfrmRec.btnGClick(Sender: TObject);
begin
  qryRec.Active := False;
  qryRec.SQL.Text := 'DELETE FROM tblDams WHERE HeightOfWall < 11.50';
  qryRec.ExecSQL;
  MessageDlg('Records Processed Successfully',mtInformation,[mbok],0);
end;

end.
